﻿/// <reference path="./jimu.d.ts" />
/// <reference path="./arcgis-js-api.d.ts" />

import BaseWidget = require("jimu/BaseWidget");
import Map = require("esri/map");

class WidgetHelper
{

	baseClass: string = "jimu-widget-customwidget";

	createWidgetProps(): any
	{
		var props: any = {};
		props["baseClass"] = this.baseClass;
		props["intWidgetHelper"] = this;  
		// In the startup function context, "this" is the actual widget
		props["startup"] = function () { this.intWidgetHelper.initialize(this); }  
		// The remaining functions use lambda expressions so that "this" is the WidgetHelper instance
		props["onOpen"] = () => { this.onOpen(); }
		props["onClose"] = () => { this.onClose(); }
		return props;
	}

	private _bw: BaseWidget; // Use this to make BaseWidget calls
	private _map: Map;

	initialize(widget: any): void
	{
		this._bw = widget;
		this._map = this._bw.map;
	}

	onOpen(): void
	{
		console.log("onOpen");
	}

	onClose(): void
	{
		console.log("onClose");
	}

}
export = WidgetHelper;
 